const {classes: Cc, interfaces: Ci, utils: Cu} = Components;
Cu.import("resource://gre/modules/Services.jsm");
var self = this, addon = {
	getResourceURI: function(filePath)
	{
		return {spec: __SCRIPT_URI_SPEC__ + "/../" + filePath}
	}
};

function include(path)
{
	Services.scriptloader.loadSubScript(addon.getResourceURI(path).spec, self);
}

function main(window)
{
	if (!window || !"gFolderTreeView" in window)
		return;

	var gFolderTreeView = window.gFolderTreeView;
	var ftvItem = window.ftvItem;
	var nsMsgFolderFlags = window.nsMsgFolderFlags;
	var sortFolderItems = window.sortFolderItems;
	var backup = window.gFolderTreeView._addSmartFoldersForFlag;

	let cleanup = function()
	{
		if (!"gFolderTreeView" in window)
			return;

		window.gFolderTreeView._addSmartFoldersForFlag = backup;
		window.gFolderTreeView.mode = window.gFolderTreeView.mode
	}
	listen(window, window, "unload", unload(cleanup), false);


//chrome://messenger/content/folderPane.js (TB v48.0)
	window.gFolderTreeView._addSmartFoldersForFlag = function ftv_addSFForFlag(map, accounts, smartRootFolder,
																									 flag, folderName, position)
{
	let subFolders = gFolderTreeView._allSmartFolders(accounts, flag, folderName, false);

	//basically this part is what was removed, the rest is identical to the original

 /*
   // If there's only one subFolder, just put it at the root.
    let subFolders = gFolderTreeView._allSmartFolders(accounts, flag, folderName, false);
    if (flag && subFolders.length == 1) {
      let folderItem = new ftvItem(subFolders[0]);
      folderItem._level = 0;
      if (flag & nsMsgFolderFlags.Inbox)
        folderItem.__defineGetter__("children", () => []);
      if (position == undefined)
        map.push(folderItem);
      else
        map[position] = folderItem;
      // No smart folder was added
      return null;
    }
*/

    let smartFolder;
    try {
      let folderUri = smartRootFolder.URI + "/" + encodeURI(folderName);
      smartFolder = smartRootFolder.getChildWithURI(folderUri, false, true);
    } catch (ex) {
        smartFolder = null;
    };
    if (!smartFolder) {
      let searchFolders = gFolderTreeView._allSmartFolders(accounts, flag, folderName, true);
      let searchFolderURIs = "";
//      for (let searchFolder of searchFolders) {
//compatibility with TB <13.0
			for each (let searchFolder in searchFolders) {
        if (searchFolderURIs.length)
          searchFolderURIs += '|';
        searchFolderURIs +=  searchFolder.URI;
      }
      if (!searchFolderURIs.length)
        return null;
      smartFolder = gFolderTreeView._createVFFolder(folderName, smartRootFolder,
                                                    searchFolderURIs, flag);
    }

    let smartFolderItem = new ftvItem(smartFolder);
    smartFolderItem._level = 0;
    if (position == undefined)
      map.push(smartFolderItem);
    else
      map[position] = smartFolderItem;
    // Add the actual special folders as sub-folders of the saved search.
    // By setting _children directly, we bypass the normal calculation
    // of subfolders.
//compatibility with TB <13.0
//    smartFolderItem._children = subFolders.map(f => new ftvItem(f));
		smartFolderItem._children = [];
		for each (let f in subFolders)
			smartFolderItem._children.push(new ftvItem(f));

    let prevChild = null;
    // Each child is a level one below the smartFolder
//compatibility with TB <13.0
//    for (let child of smartFolderItem._children) {
		for each (let child in smartFolderItem._children) {
      child._level = smartFolderItem._level + 1;
      child._parent = smartFolderItem;
      // don't show sub-folders of the inbox, but I think Archives/Sent, etc
      // should have the sub-folders.
      if (flag & nsMsgFolderFlags.Inbox)
//compatibility with TB <13.0
//        child.__defineGetter__("children", () => []);
				child.__defineGetter__("children", function(){return []});
      // If we have consecutive children with the same server, then both
      // should display as folder - server.
      if (prevChild && (child._folder.server == prevChild._folder.server)) {
        child.addServerName = true;
        prevChild.addServerName = true;
        prevChild.useServerNameOnly = false;
      }
      else if (flag)
        child.useServerNameOnly = true;
      else
        child.addServerName = true;
      prevChild = child;
    }
    // new custom folders from addons may contain lots of children, sort them
    if (flag == 0)
      sortFolderItems(smartFolderItem._children);
    return smartFolderItem;
} //end _addSmartFoldersForFlag ftv_addSFForFlag

	//activating
	window.gFolderTreeView.mode = window.gFolderTreeView.mode;
}

function startup(data, reason)
{
	include("includes/utils.js");
	watchWindows(main);
}

function shutdown(data, reason)
{
	unload();
}

function install(data, reason)
{
}

function uninstall(data, reason)
{
}
